/*

    Zelda Return of the Hylian

    Copyright (C) 2005-2008  Vincent Jouillat

    Please send bugreports with examples or suggestions to www.zeldaroth.fr Bugreports for Linux and Windows version

    Port and fix SDL for AmigaOS 4x and Morphos Hugues Nouvel HunoPPC (2009 Amiga Rulez)

    Bugreports for AmigaOS 4x and Morphos version to nouvel.hugues@orange.fr

    BugFix Audio for AOS4
*/
																
#ifndef __AUDIO_H__
#define __AUDIO_H__

#include <SDL/SDL_mixer.h>

class Audio {
    public :
        Audio();
        ~Audio();
        void playSound(int id, int chl = -1);
        void playMusic(int id);
        void stopMusic();
        void replayMusic();
        void playSpecial(int id);
        void stopSpecial();
        void setVolume(int volume);
        void setVolson(int volson);
		int getVolume() const;
        int getVolson() const;
		bool isSpecial();
    private :
        void loadSounds();
        void freeSounds();
        Mix_Music* choixMusique(int id);
        Mix_Music* choixSpecial(int id);
        
        bool SOUND;
        int previous_volume;
        int musiqueId;
        int specialId;
        Mix_Chunk** sons;
        Mix_Music* music;
		int volume;
        int volson;
};

#endif  // Audio.h
